// Copyright (c) 2022 HTC Corporation. All Rights Reserved.

#include "ViveOpenXRFacialTrackingFunctionLibrary.h"
#include "ViveOpenXRFacialTracking.h"

void UViveOpenXRFacialTrackingFunctionLibrary::GetIsFacialTrackingEnabled(bool& result)
{
	if (!GetViveOpenXRFacialTrackingModule().FTSource.IsValid()) return;
	result = GetViveOpenXRFacialTrackingModule().FTSource->m_bEnableFacialTracking;
}

bool UViveOpenXRFacialTrackingFunctionLibrary::CreateFacialTracker(EXrFacialTrackingType trackingType)
{
	XrFacialTrackingTypeHTC trackType = static_cast<XrFacialTrackingTypeHTC>(trackingType);
	if (!GetViveOpenXRFacialTrackingModule().FTSource.IsValid()) return false;
	return GetViveOpenXRFacialTrackingModule().FTSource->CreateFacialTracker(trackType);
}

bool UViveOpenXRFacialTrackingFunctionLibrary::DestroyFacialTracker()
{
	if (!GetViveOpenXRFacialTrackingModule().FTSource.IsValid()) return false;
	return GetViveOpenXRFacialTrackingModule().FTSource->DestroyFacialTracker();
}

bool UViveOpenXRFacialTrackingFunctionLibrary::GetEyeFacialExpressions(bool& isActive, TMap<EEyeShape, float>& blendshapes)
{
	if (!GetViveOpenXRFacialTrackingModule().FTSource.IsValid()) return false;
	return GetViveOpenXRFacialTrackingModule().FTSource->GetEyeExpressions(isActive, blendshapes);
}

bool UViveOpenXRFacialTrackingFunctionLibrary::GetLipFacialExpressions(bool& isActive, TMap<ELipShape, float>& blendshapes)
{
	if (!GetViveOpenXRFacialTrackingModule().FTSource.IsValid()) return false;
	return GetViveOpenXRFacialTrackingModule().FTSource->GetLipExpressions(isActive, blendshapes);
}