// Copyright (c) 2022 HTC Corporation. All Rights Reserved.

#pragma once

#include "CoreMinimal.h"
#include "UObject/ObjectMacros.h"
#include "UObject/Object.h"
#include "Engine/EngineTypes.h"

DECLARE_LOG_CATEGORY_EXTERN(LogViveOpenXRSettings, Log, All);

#include "ViveOpenXRRuntimeSettings.generated.h"


UCLASS(config = Engine, defaultconfig)
class VIVEOPENXRRUNTIMESETTINGS_API UViveOpenXRRuntimeSettings : public UObject
{
public:
  GENERATED_BODY()

    UPROPERTY(GlobalConfig, EditAnywhere, Category = "Cosmos Controller", Meta = (ConfigRestartRequired = true, DisplayName = "Enable Cosmos Controller", Tooltip = "Enable Cosmos Controller."))
        bool bEnableCosmosController = true;

    UPROPERTY(GlobalConfig, EditAnywhere, Category = "Facial Tracking", Meta = (ConfigRestartRequired = true, DisplayName = "Enable Facial Tracking", Tooltip = "Enable Facial Tracking."))
        bool bEnableFacialTracking = false;
    
    UPROPERTY(GlobalConfig, EditAnywhere, Category = "Scene Understanding", Meta = (ConfigRestartRequired = true, DisplayName = "Enable Scene Understanding", Tooltip = "Enable Scene Understanding."))
        bool bEnableSceneUnderstanding = false;
};
